# version 110
uniform sampler2D shade_tex;
uniform int RV_shade_tex_YFLIP;

uniform vec3 light_dir;
uniform float param;

varying vec2 fuv;
varying vec3 vnormal;
vec4 mmu_texture2D(sampler2D tex, vec2 uv, int RV_YFLIP){
    if(RV_YFLIP > 0) uv.y = 1.0 - uv.y;
    return texture2D(tex, uv);
}
void main(){
   vec4 tex_color = mmu_texture2D(shade_tex, fuv, RV_shade_tex_YFLIP).rgba;
   if(tex_color.a == 0.0)
       discard;
   vec3 n = vnormal;
   n = normalize(n);
   float d = clamp(dot(n,light_dir) * 0.5 + 0.5, 0.0, 1.0);
   if(d < 0.5)
   {
       d = 0.0;
   }
   else if(d < 0.78)
   {
       d = (d - 0.5) / (0.78 - 0.5) * 0.9;
   }
   else
   {
       d = (d - 0.78) / (1.0 - 0.78) * (1.0 - 0.9) + 0.9;
   }

   float v = (param * 0.6 + 0.2) * 0.56;
   d = 1.4*d*v - v + 0.5;

   gl_FragColor = vec4(d, 1.0, 1.0, 1.0);
}
