# version 110
attribute vec3 InPos;
attribute vec3 InNormal;
attribute vec2 InUv;
uniform int window_width;
uniform int window_height;
uniform float model_mat[16];
varying vec2 fuv;
varying float depth;
vec3 apply_model_matrix(vec3 v){
    vec4 ret = vec4(v, 1.0);
    float x = dot(ret, vec4(model_mat[0], model_mat[1], model_mat[2], model_mat[3]));
    float y = dot(ret, vec4(model_mat[4], model_mat[5], model_mat[6], model_mat[7]));
    float z = dot(ret, vec4(model_mat[8], model_mat[9], model_mat[10], model_mat[11]));
    float w = dot(ret, vec4(model_mat[12], model_mat[13], model_mat[14], model_mat[15]));

    return vec3(x, y, z) / w;
}
void main(){
    vec3 vert = InPos.xyz;
    vert = apply_model_matrix(vert);
    gl_Position = vec4(vert.x, vert.y, 0.5+vert.z*0.1, 1.0);
	fuv = InUv;
    depth  = vert.z;
}
