#version 110
varying vec2 fuv;
uniform sampler2D tex_bg;
uniform int RV_tex_bg_YFLIP;
uniform sampler2D tex_shading;
uniform int RV_tex_shading_YFLIP;
uniform sampler2D tex_skin;
uniform int RV_tex_skin_YFLIP;

uniform int pass2_shadingmap_x_revert;

uniform int blendtype;

vec2 shadinguv()
{
   vec2 ret = fuv;
   if(pass2_shadingmap_x_revert == 1) ret.x = 1.0 - ret.x;
   return ret;
}
vec2 bguv()
{
   vec2 ret = fuv;
   return ret;
}
vec4 mmu_texture2D(sampler2D tex, vec2 uv, int RV_YFLIP){
    if(RV_YFLIP > 0) uv.y = 1.0 - uv.y;
    return texture2D(tex, uv);
}
float get_smooth_alpha_less(float v, float thres, float reg)
{
   if(v < thres - reg) return 1.0;
   if(v > thres + reg) return 0.0;
   return (v - (thres+reg)) / (-2.0*reg);
}
float _is_skin(vec3 color)
{
   float x0 = color.r;
   float x1 = color.g;
   float x2 = color.b;
   float x3 = dot(vec3(0.5,-0.4187,-0.0813), color);
   float x4 = dot(vec3(-0.1687,-0.3313,0.5), color);
   float pos = 0.0;
   float a1 = get_smooth_alpha_less(x4, -0.0615369, 0.05);
   float a2 = get_smooth_alpha_less(x3, 0.0678488, 0.05);
   float a3 = get_smooth_alpha_less(x3, 0.0352417, 0.05);
   float a4 = get_smooth_alpha_less(x2, 0.686631, 0.05);
   float a5 = get_smooth_alpha_less(x3, 0.185183, 0.05);
   float a6 = get_smooth_alpha_less(x4, -0.029597, 0.05);
   float a7 = get_smooth_alpha_less(x3, 0.0434402, 0.05);
   float a8 = get_smooth_alpha_less(x1, 0.168271, 0.05);
   pos = a1* ( a2*(1.0-a3)*(1.0-a4) + (1.0-a2)*a5 ) + (1.0-a1)*a6*(1.0-a7)*(1.0-a8) ;
   pos = clamp(pow(pos, 0.3), 0.0, 1.0);
   return pos;
}

vec3 _apply_gamma_based_on_shading_wutai(vec3 c, float shading)
{
    vec3 new_color;
    float inten = shading - 0.5;
    new_color = c + inten;

    new_color = clamp(new_color, vec3(0.0, 0.0, 0.0), vec3(1.0, 1.0, 1.0));
    
    return new_color;
}

vec3 get_blending_pixel(vec3 bg, vec4 shading, vec3 skin){
    float is_skin = _is_skin(skin) * shading.g;

    //return skin;//vec3(shading.g);
    
    return _apply_gamma_based_on_shading_wutai(bg, shading.r)*is_skin + bg*(1.0-is_skin);
    
}
vec4 getshading()
{
    vec4 shade = mmu_texture2D(tex_shading, shadinguv(), RV_tex_shading_YFLIP).rgba;
    return shade;
}
void main(){
    vec4 shading = getshading();
    vec4 bg = mmu_texture2D(tex_bg, bguv(), RV_tex_bg_YFLIP).rgba;

    vec3 skin = mmu_texture2D(tex_skin, bguv(), RV_tex_skin_YFLIP).rgb;
    gl_FragColor = vec4(get_blending_pixel(bg.rgb, shading, skin), bg.a);
}
