#version 110
attribute vec3 InPos;
attribute vec2 InUv;
varying vec2 fuv;
varying vec2 transformed_uv;
varying mat2 rot;

uniform vec2 wh;
uniform vec3 center_rot;
uniform float aspect;
uniform int mirror;

void main(){
    gl_Position = vec4(InPos.x, InPos.y, 0.5, 1.0);
    fuv = vec2(InUv.x, InUv.y);

    float costhita = cos(center_rot.z);
    float sinthita = sin(center_rot.z);
    rot = mat2(costhita, -sinthita,
                   sinthita, costhita);

    mat2 m1 = mat2(aspect,0,
                    0, 1);
    mat2 m2 = mat2(1./aspect,0,
                    0, 1);
    mat2 m3 = mat2(1./wh.x,0,
                   0, 1./wh.y);
    rot = m1 * rot * m2;

    transformed_uv = (fuv  - center_rot.xy) * rot * m3 + vec2(0.5);

    if(mirror == 1)
        transformed_uv.x = 1. - transformed_uv.x;
}
